PORTAL.EmancipationGrill = object_add();
object_set_sprite(PORTAL.EmancipationGrill, sprite64);
object_set_visible(PORTAL.EmancipationGrill, false);

object_event_add(PORTAL.Cube, ev_collision, PORTAL.EmancipationGrill, '
    event_user(3);
');

object_event_add(PORTAL.Turret, ev_collision, PORTAL.EmancipationGrill, '
    event_user(3);
    held = false;
');

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Projectile that spawns a portal when it hits the wallmask.
PORTAL.Projectile = object_add();
object_set_parent(PORTAL.Projectile, BladeB); // Behave like a blade because it flies straight.
object_set_sprite(PORTAL.Projectile, PORTAL.ProjectileS);

object_event_add(PORTAL.Projectile, ev_create, 0, '
    color = c_white;

    hitDamage = 10;
    baseDamage = hitDamage;
');

// Prevent unused events from inheriting.
object_event_add(PORTAL.Projectile, ev_step, ev_step_begin, '');
object_event_add(PORTAL.Projectile, ev_step, ev_step_end, '');

object_event_add(PORTAL.Projectile, ev_destroy, 0, '
    gunSetSolids();
    var portal, dir, offset;
    portal = noone;
    dir = 1;
    offset = 2;

    // Only stick to the wallmask.
    // There is some 60 fps inconsistency here, adding a bit to the position seems to be required in 30 fps mode.
    if (place_meeting(x + lengthdir_x(offset, image_angle), y + lengthdir_y(offset, image_angle), Obstacle) &&
       !place_meeting(x + lengthdir_x(offset, image_angle), y + lengthdir_y(offset, image_angle), PORTAL.Portal)) {

        really_move_contact_solid(image_angle, speed);
        if (global.isHost == true) {
            if (place_free(x, y + 30) && place_free(x, y - 30)) {
                if (image_angle > 90 && image_angle < 270) {
                    dir *= -1;
                }

                if (!place_free(x + offset * dir, y + 30) && !place_free(x + offset * dir, y - 30)) {
                    portal = execute_string(PORTAL.SendPlacePortal, x, y, 90 + dir * 90, color);
                }
            } else if (place_free(x + 30, y) && place_free(x - 30, y)) {
                if (image_angle > 0 && image_angle < 180) {
                    dir *= -1;
                }

                if (!place_free(x + 30, y + offset * dir) && !place_free(x - 30, y + offset * dir)) {
                    portal = execute_string(PORTAL.SendPlacePortal, x, y, dir * 90, color);
                }
            } else if (place_free(x - 24, y - 24) && place_free(x + 24, y + 24)) {
                if (image_angle > 135 && image_angle < 315) {
                    dir *= -1;
                }

                if (!place_free(x - 24 + offset * dir, y - 24 - offset * dir) && !place_free(x + 24 + offset * dir, y + 24 - offset * dir)) {
                    portal = execute_string(PORTAL.SendPlacePortal, x, y, dir * 90 + 135, color);
                }
            } else if (place_free(x - 24, y + 24) && place_free(x + 24, y - 24)) {
                if (image_angle > 45 && image_angle < 225) {
                    dir *= -1;
                }

                if (!place_free(x - 24 + offset * dir, y + 24 + offset * dir) && !place_free(x + 24 + offset * dir, y - 24 + offset * dir)) {
                    portal = execute_string(PORTAL.SendPlacePortal, x, y, dir * 90 + 45, color);
                }
            }

            // Make sure only one portal exists.
            if (portal != noone) {
                with(PORTAL.Portal) {
                    if (color == other.color && id != portal) {
                        execute_string(PORTAL.SendDestroyPortal, id);
                    }
                }
            }
        }
    }

    execute_string(PORTAL.SpawnParticles, x, y, image_angle + 180, color);
    gunUnsetSolids();
');

object_event_add(PORTAL.Projectile, ev_draw, 0, '
    draw_sprite_ext(sprite_index, 0, x, y, image_xscale, image_yscale, image_angle, color, image_alpha);
');

object_event_add(PORTAL.Projectile, ev_collision, PORTAL.EmancipationGrill, '
    if (!global.mapchanging) {
        var imp;
        gunSetSolids();
        really_move_contact_solid(direction, speed);
        gunUnsetSolids();

        imp = instance_create(x,y,Impact);
        imp.image_angle=direction;
        instance_destroy();
    }
');

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Teleport bullets and stuff
object_event_add(Shot, ev_collision, PORTAL.Portal, '
    execute_string(PORTAL.TeleportProjectile, id, other.id);
');

object_event_add(Needle, ev_collision, PORTAL.Portal, '
    execute_string(PORTAL.TeleportProjectile, id, other.id,);
');

object_event_add(Mine, ev_collision, PORTAL.Portal, '
    stickied = false;
    execute_string(PORTAL.TeleportProjectile, id, other.id);
');

object_event_add(BurningProjectile, ev_collision, PORTAL.Portal, '
    execute_string(PORTAL.TeleportProjectile, id, other.id);
');

object_event_add(Rocket, ev_collision, PORTAL.Portal, '
    execute_string(PORTAL.TeleportProjectile, id, other.id);
');
